<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Vue Router</title>
    <style>
        @import url('https://fonts.googleapis.com/css2?family=Oswald&family=Roboto&display=swap');
        @import url('https://fonts.googleapis.com/css2?family=Oswald&display=swap');

        body{
            font-family: 'Oswald', sans-serif;
            margin: 0;
            background-color: #fafafa;
        }
        .header1{
            
            /* display?: ; */
            text-align: center;
            justify-content: center;
            background: rgb(162,238,245);
            background: radial-gradient(circle, rgba(162,238,245,1) 0%, rgba(53,226,241,1) 100%);
            padding: 5px;
        }
        .header2{
            display: flex;
            justify-content: space-between;
            font-size: larger;
            width: 20vw;
            position: relative;
            left: 40%;
        }
        .routed_page{
            margin-left: 70px;
        }
        .status{
            font-family: 'Roboto',sans-serif;
            position: absolute;
            left: 5%;
            top: 0%;
            font-size: larger;
            background-color: rgb(223, 61, 61);
            padding: 17px;
            padding-bottom: 30px;
            color: #f4f4f4;
        }
        .status_text{
            color: #f4f4f4;
        }
        .form_in{
            font-family: 'Roboto',sans-serif;
            width: 200px;
            height: 30px;
        }
        .btn{
            background-color: rgb(240, 240, 116);
            box-shadow: 1px 2px 4px 1px rgba(0, 0, 0, 0.25);
            opacity: 0.8;
            border: 1px solid rgba(0, 0, 0, 0.7);
            
            
        }
        .btn:active{
            opacity: 50%;
            transform: scale(92%);
        }
    </style>
</head>
<body>
    <div id="app">
        <div class="header1">
            <h1>
                Vue Router Navigation
            </h1>
            <div class="status" :status='status_login'>
                
                <p> 
                    Status anda saat ini adalah:
                    <br>
                    <router-link class="status_text" to="/">
                        <u> <b>Anda {{status_login}} </b> </u>
                    </router-link>
                </p>
                <input class="form_in btn" v-if="val.length > 0" type="button" @click='logout' value="LOGOUT">
            </div>
        </div>
        <div class="header2">

            <router-link to="/">
                <p>Home</p>
            </router-link>
            <router-link to="/halaman1">
                <p>Halaman 1</p>
            </router-link>
            <router-link to="/halaman2">
                <p>Halaman 2</p>
            </router-link>
            <router-link to="/halaman3">
                <p>Halaman 3</p>
            </router-link>
        </div>


        <div class="routed_page">
            <!-- Catch the events -->
            <router-view
            @login-method='loginMethod'
            ></router-view>
        </div>

    </div>


    <!-- Home Template -->
    <template id="home">
        <div>
            <br>
            <h1>Selamat Datang di Home Page</h1>
            <p>Page ini bisa diakses siapa saja
                <br>
                Disini anda bisa login
            </p>

            <form @submit.prevent='$emit("login-method",selected)' action="">
                <select class="form_in " v-model="selected" name="" id="login">
                    <option value="" disabled selected> Pilih Tipe Login</option>
                    <option value="1">Login Sebagai User Biasa</option>
                    <option value="2">Login Sebagai Admin</option>
                </select>
                <input class="form_in btn" type="submit" value="LOGIN">
            </form>
            
        </div>

    </template>
    <!-- Component1 Template -->
    <template id="component_1">
        <div>
            <br>
            <h1>Selamat Datang di Component 1</h1>
            <h3>Page ini bisa diakses siapa saja</h3>
            <img src="" alt="">
        </div>

    </template>
    
    
    <!-- Component2 Template -->
    <template id="component_2">
        <div>
            <br>
            <h1>Selamat Datang di Component 2</h1>
            <h3>Page ini hanya bisa diakses oleh orang yang sudah login saja</h3>
        </div>

    </template>
    
    
    
    <!-- Component3 Template -->
    <template id="component_3">
        <div>
            <br>
            <h1>Selamat Datang di Component 3</h1>
            <h3>Page in hanya bisa diakses oleh admin</h3>
        </div>

    </template>


    <script src="https://unpkg.com/vue/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router/dist/vue-router.js"></script>

    <script>
        // Global variables
        localStorage.setItem('login_status',0)
        
        // Components
        var Home={
            template:'#home',
            data() {
                return {
                    selected:''
                }
            },
        }
        var Component1={
            template:'#component_1'
        }
        var Component2={
            template:'#component_2'
        }
        var Component3={
            template:'#component_3'
        }

        const routes = [
            { path: '/halaman1', component: Component1 },
            { path: '/halaman2', component: Component2 },
            { path: '/halaman3', component: Component3 },
            { path: '/', component: Home },
            { path: '*', component: Home },
        
        ]


        const router = new VueRouter({
            routes     
        })

        // NAVIGATION GUARD
        router.beforeEach((to, from, next) => {
            var auth = JSON.parse(localStorage.getItem('login_status'))

            // to and from are both route objects. must call `next`.
            if(to.path === '/') next()
            if(to.path === '/halaman1') next()

            if(to.path === '/halaman2') {
                if (auth === 1) next()
                else {
                    alert('Anda harus login sebagai user')
                    next(false)}
            }
            if(to.path === '/halaman3') {
                if (auth === 2) next()
                else {
                    alert('Anda harus login sebagai admin')
                    next(false)}
            }
            
        })

        const vm = new Vue({
            el:'#app',
            components:{
                'home':Home,
                 'component_1':Component1,
                 'component_2':Component2,
                 'component_3':Component3,
            },
            router,
            data() {
                return {
                    status_login:'belum login',
                    val:''
                }
            },
            methods: {
                loginMethod(val){
                    if(val === '1'){
                        this.status_login= 'telah login sebagai user'
                        this.val = '1'
                        localStorage.setItem('login_status',1) 
                    }
                    if(val === '2'){
                        this.status_login = 'telah login sebagai admin'
                        this.val ='2'
                        localStorage.setItem('login_status',2) 
                    }
                },
                logout(){
                    this.status_login='belum login'
                    this.val=''
                    localStorage.setItem('login_status',0)
                    if (this.$route.path !== '/') router.push('/')
                }
            },
            computed:{
                
            }
        })
    </script>
</body>
</html>